// FoxClocks extension for Mozilla Firefox/Thunderbird/Sunbird
// Copyright (C) 2006 Andy McDonald / www.stemhaus.com
// For licensing terms, please refer to readme.txt in this extension's '.xpi'
// package or its installation directory on your computer.

// AFM - majority of this stuff to be moved to components
//

// ====================================================================================
const FC_URL_FOXCLOCKSHOME = "http://www.stemhaus.com/firefox/foxclocks/";
const FC_URL_FOXCLOCKSCHANGELOG = "http://www.stemhaus.com/firefox/foxclocks/index.html#changelog";
const FC_URL_CUSTTOOLBAR_SUNBIRD = "chrome://calendar/content/customizeToolbar.xul";
const FC_URL_CUSTTOOLBAR_FX_TB = "chrome://global/content/customizeToolbar.xul";
															
const FC_REGEXP_VALID_LATDEG = /^\d{1,2}$/;
const FC_REGEXP_VALID_LONGDEG = /^\d{1,3}$/;
const FC_REGEXP_VALID_MIN_SEC =  /^\d{1,2}$/;
const FC_REGEXP_VALID_STATBARPOSN_INDEX = /^\d{1,}$/;
const FC_REGEXP_OPTIONSFORMATSTANDARD = /^options\.format\.standard\.(\d{1,})$/;

const FC_FOXCLOCKS_SETTINGS_EXTENSION = "fcl";
const FC_FOXCLOCKS_ZONEPICKER_EXTENSION = "fcz";

// ====================================================================================
// AFM - global services
//
var fc_gZoneManager = Components.classes["@stemhaus.com/firefox/foxclocks/zonemanager;1"].getService(Components.interfaces.nsISupports).wrappedJSObject;
var fc_gUtils = Components.classes["@stemhaus.com/firefox/foxclocks/utils;1"].getService(Components.interfaces.nsISupports).wrappedJSObject;
var fc_gLogger = Components.classes["@stemhaus.com/firefox/foxclocks/logger;1"].getService(Components.interfaces.nsISupports).wrappedJSObject;
var fc_gUpdateManager = Components.classes["@stemhaus.com/firefox/foxclocks/updatemanager;1"].getService(Components.interfaces.nsISupports).wrappedJSObject;
var fc_gPrefManager = Components.classes["@stemhaus.com/firefox/foxclocks/prefmanager;1"].getService(Components.interfaces.nsISupports).wrappedJSObject;

var fc_gPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
var fc_gObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);	
			
// ====================================================================================
function FoxClocks_openFoxClocksHomeURL(atChangeLog, progressListener)
{
	var url = atChangeLog ? FC_URL_FOXCLOCKSCHANGELOG : FC_URL_FOXCLOCKSHOME;
	var appInfo = fc_gUtils.getAppInfo();

	try
	{
		if (appInfo.appName == "Thunderbird")
		{
			var messenger = Components.classes["@mozilla.org/messenger;1"].getService(Components.interfaces.nsIMessenger);
			messenger.launchExternalURL(url);
		}
		else if (appInfo.appName == "Sunbird")
		{
			// AFM - from http://lxr.mozilla.org/mozilla/source/calendar/resources/content/applicationUtil.js#74
			//
			var externalLoader = (Components
				.classes["@mozilla.org/uriloader/external-protocol-service;1"]
				.getService(Components.interfaces.nsIExternalProtocolService));
				
			var nsURI = (Components
				.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService)
				.newURI(url, null, null));
				
			externalLoader.loadUrl(nsURI);
		}
		else if (appInfo.appName == "Firefox")
		{
			var mediatorService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var mrWindow = mediatorService.getMostRecentWindow("navigator:browser");
			
			var browser = (mrWindow ? mrWindow : window).document.getElementById("content");
			
			if (progressListener)
			{
				browser.addProgressListener(progressListener,
					Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL);
			}
			
			if (mrWindow != null)
			{
				var loc = mrWindow.content.document.location;
				
				if (loc == "about:blank")
				{
					loc.assign(url);
					mrWindow.focus();
				}
				else if (loc == url)
				{
					mrWindow.focus();
				}
				else
				{	
					var tab = browser.addTab(url);
					browser.selectedTab = tab;
				}
			}
			else
			{
				window.open(url, "FoxClocksHome", "");
			}
		}
	}
	catch(ex)
	{
		fc_gPromptService.alert(window, "FoxClocks", "FoxClocks_openFoxClocksHomeURL(): " + ex);
	}
}

// ====================================================================================
function FoxClocks_openWindow(url, internalName, displayFlags)
{
	try
	{
		var mediatorService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var enumerator = mediatorService.getEnumerator(null);
		while (enumerator.hasMoreElements())
		{
			var currWindow = enumerator.getNext();
			currWindow = currWindow.QueryInterface(Components.interfaces.nsIDOMWindowInternal);
			
			if (url == currWindow.location.href) // rhs is chrome:// URL
			{
				currWindow.focus();
				return currWindow;
			}
		}
	}
	catch (ex) { /* do nothing */ }
	
	return window.open(url, internalName, displayFlags);
}

// ====================================================================================
function FoxClocks_openSimpleInfo(title, message)
{
	window.openDialog("chrome://foxclocks/content/simpleinfo.xul", "",
			"chrome,modal,centerscreen,resizable=no", title, message);
}

// ====================================================================================
function FoxClocks_getCustomizeToolbarURL()
{	
	var appInfo = fc_gUtils.getAppInfo();
	
	if (appInfo.appName == "Sunbird")
		return FC_URL_CUSTTOOLBAR_SUNBIRD;
	else if (appInfo.appName == "Firefox" || appInfo.appName == "Thunderbird")
		return FC_URL_CUSTTOOLBAR_FX_TB;
	else
		return null;
}

// ====================================================================================
function FoxClocks_Pair(first, second)
{
	this.first = first;
	this.second = second;
}

// ====================================================================================
function FoxClocks_DisableId(id, truth)
{
	document.getElementById(id).setAttribute("disabled", (truth ? "true" : "false"));
}